Index: trunk/src/VBox/VMM/VMMAll/IEMAllAImpl.asm
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllAImpl.asm	(revision 104135)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllAImpl.asm	(revision 104136)
@@ -4897,5 +4897,5 @@
         vmovdqu  xmm1, [A3]
         v %+ %1  xmm0, xmm0, xmm1
-        vmovdqu  [A1 + IEMAVX128RESULT.uResult], xmm0
+        vmovdqu  [A1], xmm0
 
         SSE_AVX_ST_MXCSR R0_32, A0_32
@@ -4912,5 +4912,5 @@
         vmovdqu  ymm1, [A3]
         v %+ %1  ymm0, ymm0, ymm1
-        vmovdqu  [A1 + IEMAVX256RESULT.uResult], ymm0
+        vmovdqu  [A1], ymm0
 
         SSE_AVX_ST_MXCSR R0_32, A0_32
@@ -4927,5 +4927,5 @@
         vmovdqu  xmm1, [A3]
         v %+ %1  xmm0, xmm1
-        vmovdqu  [A1 + IEMAVX128RESULT.uResult], xmm0
+        vmovdqu  [A1], xmm0
 
         SSE_AVX_ST_MXCSR R0_32, A0_32
@@ -4942,5 +4942,5 @@
         vmovdqu  ymm1, [A3]
         v %+ %1  ymm0, ymm1
-        vmovdqu  [A1 + IEMAVX256RESULT.uResult], ymm0
+        vmovdqu  [A1], ymm0
 
         SSE_AVX_ST_MXCSR R0_32, A0_32
Index: trunk/src/VBox/VMM/VMMAll/IEMAllN8vePython.py
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllN8vePython.py	(revision 104135)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllN8vePython.py	(revision 104136)
@@ -619,5 +619,5 @@
 
 ### Statistics: List of variations (value) with aimpl_[^0] calls that is only missing this one statement (key).
-#g_dUnsupportedMcStmtLastOneAImplStats = {}
+g_dUnsupportedMcStmtLastOneAImplStats = {}
 
 
@@ -653,29 +653,30 @@
                 g_dUnsupportedMcStmtLastOneStats[sStmt] = [oVariation,];
 
-    #if (    len(dUnsupportedStmts) in (1,2)
-    #    and iai.McStmt.findStmtByNames(aoStmts,
-    #                                   { 'IEM_MC_CALL_AIMPL_3': 1,
-    #                                     'IEM_MC_CALL_AIMPL_4': 1,
-    #                                     #'IEM_MC_CALL_VOID_AIMPL_0': 1, - can't test results... ?
-    #                                     'IEM_MC_CALL_VOID_AIMPL_1': 1,
-    #                                     'IEM_MC_CALL_VOID_AIMPL_2': 1,
-    #                                     'IEM_MC_CALL_VOID_AIMPL_3': 1,
-    #                                     'IEM_MC_CALL_VOID_AIMPL_4': 1,
-    #                                     #'IEM_MC_CALL_FPU_AIMPL_1': 1,
-    #                                     #'IEM_MC_CALL_FPU_AIMPL_2': 1,
-    #                                     #'IEM_MC_CALL_FPU_AIMPL_3': 1,
-    #                                     #'IEM_MC_CALL_MMX_AIMPL_2': 1,
-    #                                     #'IEM_MC_CALL_MMX_AIMPL_3': 1,
-    #                                     #'IEM_MC_CALL_SSE_AIMPL_2': 1,
-    #                                     #'IEM_MC_CALL_SSE_AIMPL_3': 1,
-    #                                     #'IEM_MC_CALL_AVX_AIMPL_2': 1,
-    #                                     #'IEM_MC_CALL_AVX_AIMPL_3': 1,
-    #                                     #'IEM_MC_CALL_AVX_AIMPL_4': 1,
-    #                                    })):
-    #    for sStmt in dUnsupportedStmts:
-    #        if sStmt in g_dUnsupportedMcStmtLastOneAImplStats:
-    #            g_dUnsupportedMcStmtLastOneAImplStats[sStmt].append(oVariation);
-    #        else:
-    #            g_dUnsupportedMcStmtLastOneAImplStats[sStmt] = [oVariation,];
+    if (    len(dUnsupportedStmts) in (1,2)
+        and iai.McStmt.findStmtByNames(aoStmts,
+                                       { 'IEM_MC_CALL_AIMPL_3': 1,
+                                         'IEM_MC_CALL_AIMPL_4': 1,
+                                         #'IEM_MC_CALL_VOID_AIMPL_0': 1, - can't test results... ?
+                                         'IEM_MC_CALL_VOID_AIMPL_1': 1,
+                                         'IEM_MC_CALL_VOID_AIMPL_2': 1,
+                                         'IEM_MC_CALL_VOID_AIMPL_3': 1,
+                                         'IEM_MC_CALL_VOID_AIMPL_4': 1,
+                                         'IEM_MC_CALL_FPU_AIMPL_1': 1,
+                                         'IEM_MC_CALL_FPU_AIMPL_2': 1,
+                                         'IEM_MC_CALL_FPU_AIMPL_3': 1,
+                                         'IEM_MC_CALL_MMX_AIMPL_2': 1,
+                                         'IEM_MC_CALL_MMX_AIMPL_3': 1,
+                                         'IEM_MC_CALL_SSE_AIMPL_2': 1,
+                                         'IEM_MC_CALL_SSE_AIMPL_3': 1,
+                                         'IEM_MC_CALL_AVX_AIMPL_2': 1,
+                                         'IEM_MC_CALL_AVX_AIMPL_3': 1,
+                                         'IEM_MC_CALL_AVX_AIMPL_4': 1,
+                                         'IEM_MC_CALL_AVX_AIMPL_NEW_3': 1,
+                                        })):
+        for sStmt in dUnsupportedStmts:
+            if sStmt in g_dUnsupportedMcStmtLastOneAImplStats:
+                g_dUnsupportedMcStmtLastOneAImplStats[sStmt].append(oVariation);
+            else:
+                g_dUnsupportedMcStmtLastOneAImplStats[sStmt] = [oVariation,];
 
     return None;
@@ -720,5 +721,5 @@
     if g_dUnsupportedMcStmtLastOneStats:
         asTopKeys = sorted(g_dUnsupportedMcStmtLastOneStats, reverse = True,
-                           key = lambda sSortKey: len(g_dUnsupportedMcStmtLastOneStats[sSortKey]))[:16];
+                           key = lambda sSortKey: len(g_dUnsupportedMcStmtLastOneStats[sSortKey]));
         print('todo:', file = sys.stderr);
         print('todo: Top %s variations with one unsupported statement dependency:' % (len(asTopKeys),),
@@ -733,5 +734,5 @@
 
         asTopKeys = sorted(g_dUnsupportedMcStmtStats, reverse = True,
-                           key = lambda sSortKey: g_dUnsupportedMcStmtStats[sSortKey])[:16];
+                           key = lambda sSortKey: g_dUnsupportedMcStmtStats[sSortKey]);
         print('todo:', file = sys.stderr);
         print('todo: Top %d most used unimplemented statements:' % (len(asTopKeys),), file = sys.stderr);
@@ -749,17 +750,17 @@
         print('todo:', file = sys.stderr);
 
-    #if g_dUnsupportedMcStmtLastOneAImplStats:
-    #    asTopKeys = sorted(g_dUnsupportedMcStmtLastOneAImplStats, reverse = True,
-    #                       key = lambda sSortKey: len(g_dUnsupportedMcStmtLastOneAImplStats[sSortKey]))[:16];
-    #    print('todo:', file = sys.stderr);
-    #    print('todo: Top %s variations with AIMPL call and 1-2 unsupported statement dependencies:' % (len(asTopKeys),),
-    #          file = sys.stderr);
-    #    cchMaxKey = max([len(sKey) for sKey in asTopKeys]);
-    #    for sKey in asTopKeys:
-    #        print('todo: %*s = %s (%s%s)'
-    #              % (cchMaxKey, sKey, len(g_dUnsupportedMcStmtLastOneAImplStats[sKey]),
-    #                 ', '.join([oVar.getShortName() for oVar in g_dUnsupportedMcStmtLastOneAImplStats[sKey][:5]]),
-    #                 ',...' if len(g_dUnsupportedMcStmtLastOneAImplStats[sKey]) >= 5 else '', )
-    #                 , file = sys.stderr);
+    if g_dUnsupportedMcStmtLastOneAImplStats:
+        asTopKeys = sorted(g_dUnsupportedMcStmtLastOneAImplStats, reverse = True,
+                           key = lambda sSortKey: len(g_dUnsupportedMcStmtLastOneAImplStats[sSortKey]));
+        print('todo:', file = sys.stderr);
+        print('todo: Top %s variations with AIMPL call and 1-2 unsupported statement dependencies:' % (len(asTopKeys),),
+              file = sys.stderr);
+        cchMaxKey = max([len(sKey) for sKey in asTopKeys]);
+        for sKey in asTopKeys:
+            print('todo: %*s = %s (%s%s)'
+                  % (cchMaxKey, sKey, len(g_dUnsupportedMcStmtLastOneAImplStats[sKey]),
+                     ', '.join([oVar.getShortName() for oVar in g_dUnsupportedMcStmtLastOneAImplStats[sKey][:5]]),
+                     ',...' if len(g_dUnsupportedMcStmtLastOneAImplStats[sKey]) >= 5 else '', )
+                     , file = sys.stderr);
 
     return True;