Index: trunk/src/VBox/VMM/VMMAll/IEMAllInstVexMap1.cpp.h
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllInstVexMap1.cpp.h	(revision 104185)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllInstVexMap1.cpp.h	(revision 104186)
@@ -2345,9 +2345,6 @@
         IEM_MC_CALL_AVX_AIMPL_3(IEM_SELECT_HOST_OR_FALLBACK(fAvx, iemAImpl_vucomiss_u128, iemAImpl_vucomiss_u128_fallback),
                                 pEFlags, uSrc1, uSrc2);
-        IEM_MC_IF_MXCSR_XCPT_PENDING() {
-            IEM_MC_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
-        } IEM_MC_ELSE() {
-            IEM_MC_COMMIT_EFLAGS(fEFlags);
-        } IEM_MC_ENDIF();
+        IEM_MC_MAYBE_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
+        IEM_MC_COMMIT_EFLAGS(fEFlags);
 
         IEM_MC_ADVANCE_RIP_AND_FINISH();
@@ -2376,9 +2373,6 @@
         IEM_MC_CALL_AVX_AIMPL_3(IEM_SELECT_HOST_OR_FALLBACK(fAvx, iemAImpl_vucomiss_u128, iemAImpl_vucomiss_u128_fallback),
                                 pEFlags, uSrc1, uSrc2);
-        IEM_MC_IF_MXCSR_XCPT_PENDING() {
-            IEM_MC_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
-        } IEM_MC_ELSE() {
-            IEM_MC_COMMIT_EFLAGS(fEFlags);
-        } IEM_MC_ENDIF();
+        IEM_MC_MAYBE_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
+        IEM_MC_COMMIT_EFLAGS(fEFlags);
 
         IEM_MC_ADVANCE_RIP_AND_FINISH();
@@ -2416,9 +2410,6 @@
         IEM_MC_CALL_AVX_AIMPL_3(IEM_SELECT_HOST_OR_FALLBACK(fAvx, iemAImpl_vucomisd_u128, iemAImpl_vucomisd_u128_fallback),
                                 pEFlags, uSrc1, uSrc2);
-        IEM_MC_IF_MXCSR_XCPT_PENDING() {
-            IEM_MC_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
-        } IEM_MC_ELSE() {
-            IEM_MC_COMMIT_EFLAGS(fEFlags);
-        } IEM_MC_ENDIF();
+        IEM_MC_MAYBE_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
+        IEM_MC_COMMIT_EFLAGS(fEFlags);
 
         IEM_MC_ADVANCE_RIP_AND_FINISH();
@@ -2447,9 +2438,6 @@
         IEM_MC_CALL_AVX_AIMPL_3(IEM_SELECT_HOST_OR_FALLBACK(fAvx, iemAImpl_vucomisd_u128, iemAImpl_vucomisd_u128_fallback),
                                 pEFlags, uSrc1, uSrc2);
-        IEM_MC_IF_MXCSR_XCPT_PENDING() {
-            IEM_MC_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
-        } IEM_MC_ELSE() {
-            IEM_MC_COMMIT_EFLAGS(fEFlags);
-        } IEM_MC_ENDIF();
+        IEM_MC_MAYBE_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
+        IEM_MC_COMMIT_EFLAGS(fEFlags);
 
         IEM_MC_ADVANCE_RIP_AND_FINISH();
@@ -2490,9 +2478,6 @@
         IEM_MC_CALL_AVX_AIMPL_3(IEM_SELECT_HOST_OR_FALLBACK(fAvx, iemAImpl_vcomiss_u128, iemAImpl_vcomiss_u128_fallback),
                                 pEFlags, uSrc1, uSrc2);
-        IEM_MC_IF_MXCSR_XCPT_PENDING() {
-            IEM_MC_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
-        } IEM_MC_ELSE() {
-            IEM_MC_COMMIT_EFLAGS(fEFlags);
-        } IEM_MC_ENDIF();
+        IEM_MC_MAYBE_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
+        IEM_MC_COMMIT_EFLAGS(fEFlags);
 
         IEM_MC_ADVANCE_RIP_AND_FINISH();
@@ -2521,9 +2506,6 @@
         IEM_MC_CALL_AVX_AIMPL_3(IEM_SELECT_HOST_OR_FALLBACK(fAvx, iemAImpl_vcomiss_u128, iemAImpl_vcomiss_u128_fallback),
                                 pEFlags, uSrc1, uSrc2);
-        IEM_MC_IF_MXCSR_XCPT_PENDING() {
-            IEM_MC_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
-        } IEM_MC_ELSE() {
-            IEM_MC_COMMIT_EFLAGS(fEFlags);
-        } IEM_MC_ENDIF();
+        IEM_MC_MAYBE_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
+        IEM_MC_COMMIT_EFLAGS(fEFlags);
 
         IEM_MC_ADVANCE_RIP_AND_FINISH();
@@ -2561,9 +2543,6 @@
         IEM_MC_CALL_AVX_AIMPL_3(IEM_SELECT_HOST_OR_FALLBACK(fAvx, iemAImpl_vcomisd_u128, iemAImpl_vcomisd_u128_fallback),
                                 pEFlags, uSrc1, uSrc2);
-        IEM_MC_IF_MXCSR_XCPT_PENDING() {
-            IEM_MC_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
-        } IEM_MC_ELSE() {
-            IEM_MC_COMMIT_EFLAGS(fEFlags);
-        } IEM_MC_ENDIF();
+        IEM_MC_MAYBE_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
+        IEM_MC_COMMIT_EFLAGS(fEFlags);
 
         IEM_MC_ADVANCE_RIP_AND_FINISH();
@@ -2592,9 +2571,6 @@
         IEM_MC_CALL_AVX_AIMPL_3(IEM_SELECT_HOST_OR_FALLBACK(fAvx, iemAImpl_vcomisd_u128, iemAImpl_vcomisd_u128_fallback),
                                 pEFlags, uSrc1, uSrc2);
-        IEM_MC_IF_MXCSR_XCPT_PENDING() {
-            IEM_MC_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
-        } IEM_MC_ELSE() {
-            IEM_MC_COMMIT_EFLAGS(fEFlags);
-        } IEM_MC_ENDIF();
+        IEM_MC_MAYBE_RAISE_SSE_AVX_SIMD_FP_OR_UD_XCPT();
+        IEM_MC_COMMIT_EFLAGS(fEFlags);
 
         IEM_MC_ADVANCE_RIP_AND_FINISH();