Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerGuestTable.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerGuestTable.cpp	(revision 104226)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerGuestTable.cpp	(revision 104228)
@@ -52,4 +52,5 @@
 #include "QILineEdit.h"
 #include "QIToolBar.h"
+#include "UITranslationEventListener.h"
 
 /* COM includes: */
@@ -446,5 +447,8 @@
     setStateAndEnableWidgets();
 
-    retranslateUi();
+    sltRetranslateUI();
+
+    connect(&translationEventListener(), &UITranslationEventListener::sigRetranslateUI,
+            this, &UIFileManagerGuestTable::sltRetranslateUI);
 }
 
@@ -463,5 +467,5 @@
 }
 
-void UIFileManagerGuestTable::retranslateUi()
+void UIFileManagerGuestTable::sltRetranslateUI()
 {
     if (m_pLocationLabel)
@@ -512,5 +516,5 @@
     }
 
-    UIFileManagerTable::retranslateUi();
+    UIFileManagerTable::sltRetranslateUI();
 }
 
@@ -1523,5 +1527,5 @@
     setState();
     setSessionDependentWidgetsEnabled();
-    retranslateUi();
+    sltRetranslateUI();
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerGuestTable.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerGuestTable.h	(revision 104226)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerGuestTable.h	(revision 104228)
@@ -80,5 +80,4 @@
 protected:
 
-    void            retranslateUi() RT_OVERRIDE RT_FINAL;
     virtual bool    readDirectory(const QString& strPath, UIFileSystemItem *parent, bool isStartDir = false) RT_OVERRIDE RT_FINAL;
     virtual void    deleteByItem(UIFileSystemItem *item) RT_OVERRIDE RT_FINAL;
@@ -113,4 +112,5 @@
     void sltCommitDataSignalReceived();
     void sltAdditionsStateChange();
+    virtual void sltRetranslateUI() RT_OVERRIDE RT_FINAL;
 
 private:
Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerHostTable.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerHostTable.cpp	(revision 104226)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerHostTable.cpp	(revision 104228)
@@ -41,5 +41,5 @@
 #include "UIPathOperations.h"
 #include "QIToolBar.h"
-
+#include "UITranslationEventListener.h"
 
 /*********************************************************************************************************************************
@@ -142,5 +142,7 @@
     prepareActionConnections();
     determinePathSeparator();
-    retranslateUi();
+    sltRetranslateUI();
+    connect(&translationEventListener(), &UITranslationEventListener::sigRetranslateUI,
+            this, &UIFileManagerHostTable::sltRetranslateUI);
 }
 
@@ -184,10 +186,10 @@
 }
 
-void UIFileManagerHostTable::retranslateUi()
+void UIFileManagerHostTable::sltRetranslateUI()
 {
     if (m_pLocationLabel)
         m_pLocationLabel->setText(UIFileManager::tr("Host File System:"));
     m_strTableName = UIFileManager::tr("Host");
-    UIFileManagerTable::retranslateUi();
+    UIFileManagerTable::sltRetranslateUI();
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerHostTable.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerHostTable.h	(revision 104226)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerHostTable.h	(revision 104228)
@@ -62,5 +62,4 @@
     static bool scanDirectory(const QString& strPath, UIFileSystemItem *parent,
                               QMap<QString, UIFileSystemItem*> &fileObjects);
-    void            retranslateUi() override;
     virtual bool    readDirectory(const QString& strPath, UIFileSystemItem *parent, bool isStartDir = false) override final;
     virtual void    deleteByItem(UIFileSystemItem *item) override final;
@@ -83,4 +82,8 @@
     /** @} */
 
+protected slots:
+
+    virtual void sltRetranslateUI() RT_OVERRIDE;
+
 private:
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerTable.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerTable.cpp	(revision 104226)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerTable.cpp	(revision 104228)
@@ -50,4 +50,5 @@
 #include "UIPathOperations.h"
 #include "UITranslator.h"
+#include "UITranslationEventListener.h"
 
 /* COM includes: */
@@ -406,5 +407,5 @@
 
 UIFileManagerTable::UIFileManagerTable(UIActionPool *pActionPool, QWidget *pParent /* = 0 */)
-    :QIWithRetranslateUI<QWidget>(pParent)
+    : QWidget(pParent)
     , m_eFileOperationType(FileOperationType_None)
     , m_pLocationLabel(0)
@@ -542,4 +543,8 @@
                 this, &UIFileManagerTable::sltSearchTextChanged);
     }
+
+    connect(&translationEventListener(), &UITranslationEventListener::sigRetranslateUI,
+            this, &UIFileManagerTable::sltRetranslateUI);
+
     optionsUpdated();
 }
@@ -1039,5 +1044,5 @@
 }
 
-void UIFileManagerTable::retranslateUi()
+void UIFileManagerTable::sltRetranslateUI()
 {
     UIFileSystemItem *pRootItem = rootItem();
@@ -1056,5 +1061,5 @@
     /* Handle only events sent to m_pView: */
     if (pObject != m_pView)
-        return QIWithRetranslateUI<QWidget>::eventFilter(pObject, pEvent);
+        return QWidget::eventFilter(pObject, pEvent);
 
     if (pEvent->type() == QEvent::KeyPress)
@@ -1113,5 +1118,5 @@
 
     /* Call to base-class: */
-    return QIWithRetranslateUI<QWidget>::eventFilter(pObject, pEvent);
+    return QWidget::eventFilter(pObject, pEvent);
 }
 
@@ -1202,6 +1207,6 @@
 {
     if (pEvent->type() == QEvent::EnabledChange)
-        retranslateUi();
-    return QIWithRetranslateUI<QWidget>::event(pEvent);
+        sltRetranslateUI();
+    return QWidget::event(pEvent);
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerTable.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerTable.h	(revision 104226)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerTable.h	(revision 104228)
@@ -45,5 +45,4 @@
 #include "QIDialog.h"
 #include "QITableView.h"
-#include "QIWithRetranslateUI.h"
 #include "UIGuestControlDefs.h"
 
@@ -139,5 +138,5 @@
  *  populates the UIFileSystemModel by scanning the file system
  *  differently. The file structure kept in this class as a tree. */
-class UIFileManagerTable : public QIWithRetranslateUI<QWidget>
+class UIFileManagerTable : public QWidget
 {
     Q_OBJECT;
@@ -208,5 +207,4 @@
     };
 
-    void retranslateUi() RT_OVERRIDE;
     void updateCurrentLocationEdit(const QString& strLocation);
     /* @p index is for model not for 'proxy' model */
@@ -275,4 +273,8 @@
     /** Contains m_pBreadCrumbsWidget and m_pLocationComboBox. */
     UIFileTableNavigationWidget   *m_pNavigationWidget;
+
+protected slots:
+
+    virtual void sltRetranslateUI();
 
 private slots:
Index: trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoCreator.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoCreator.cpp	(revision 104226)
+++ trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoCreator.cpp	(revision 104228)
@@ -52,4 +52,5 @@
 #include "UIPaneContainer.h"
 #include "UIShortcutPool.h"
+#include "UITranslationEventListener.h"
 #include "UIVisoCreator.h"
 #include "UIVisoContentBrowser.h"
@@ -105,4 +106,6 @@
     :UIFileManagerHostTable(pActionPool, pParent)
 {
+    connect(&translationEventListener(), &UITranslationEventListener::sigRetranslateUI,
+            this, &UIVisoHostBrowser::sltRetranslateUI);
 }
 
@@ -145,11 +148,9 @@
 
 
-void UIVisoHostBrowser::retranslateUi()
-{
-    UIFileManagerHostTable::retranslateUi();
+void UIVisoHostBrowser::sltRetranslateUI()
+{
+    UIFileManagerHostTable::sltRetranslateUI();
     if (m_pSubMenu)
         m_pSubMenu->setTitle(QApplication::translate("UIVisoCreatorWidget", "VISO Browser"));
-
-    //setFileTableLabelText(QApplication::translate("UIVisoCreatorWidget","VISO Content"));
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoCreator.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoCreator.h	(revision 104226)
+++ trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoCreator.h	(revision 104228)
@@ -57,4 +57,6 @@
 {
 
+    Q_OBJECT;
+
 public:
 
@@ -62,8 +64,11 @@
     void prepareMainMenu(QMenu *pMenu);
 
+private slots:
+
+    virtual void sltRetranslateUI() RT_OVERRIDE RT_FINAL;
+
 private:
 
     virtual void createFileViewContextMenu(const QWidget *pWidget, const QPoint &point) RT_OVERRIDE RT_FINAL;
-    virtual void retranslateUi() RT_OVERRIDE RT_FINAL;
     QPointer<QMenu>        m_pSubMenu;
 };